import 'dart:convert';
import 'dart:io';

import 'package:bishop/bishop.dart';

import 'constants.dart';

main(List<String> args) async {
  bool showCorrect = true;
  String fen = Positions.POSITION_5;
  int depth = 3;
  Game game = Game(variant: Variant.standard(), fen: fen);
  Map<String, dynamic> results = game.divide(depth);
  results.forEach((key, value) => print('$key: $value'));

  Map<String, dynamic> stockfish = {};
  await Process.start('stockfish', []).then((Process process) {
    process.stdin.writeln('position fen $fen');
    process.stdout.transform(utf8.decoder).listen((data) {
      for (var line in data.split("\n")) {
        for (var entry in line.split(",")) {
          int colon = entry.indexOf(':');
          if (entry != null && colon != -1) {
            String key = entry.substring(0, colon);
            int value = int.parse(entry.substring(colon + 2));
            stockfish[key] = value;
            if (results[key] == null) {
              if (key.contains("searched")) {
                // end of results
                results.forEach((key, value) {
                  if (stockfish[key] == null)
                    print("Stockfish didn't generate $key, but we did");
                  else {
                    if (value != stockfish[key]) {
                      int diff = stockfish[key] - value;
                      print(
                          "Error on $key - $value (us) vs ${stockfish[key]} (stockfish) [${(diff > 0) ? "+$diff" : diff}]");
                    } else if (showCorrect) {
                      print("$key correct ($value)");
                    }
                  }
                });
              } else {
                print("$key not generated by us");
              }
            }
          }
        }
      }
      //print(stockfish);
      //print("s");
    });
    process.exitCode.then((value) {
      print("stockfish finished");
      print(stockfish);
    });
    process.stdin.writeln('go perft $depth');
    //process.kill();
  });
}
